// dbghelp_bug_6.12.2.633.cpp

#undef UNICODE
#undef _UNICODE


#include <windows.h>
#include <stdio.h>
#include <Tlhelp32.h>
#include <assert.h>
#include <dbghelp.h>
#include <tchar.h>


#pragma pack(push,8)  // be sure it has the right packing! THIS IS MISSING IN DBGHELP.H!!!!

typedef struct IMAGEHLP_MODULE64_V1 {
  DWORD    SizeOfStruct;           // set to sizeof(IMAGEHLP_MODULE64)
  DWORD64  BaseOfImage;            // base load address of module
  DWORD    ImageSize;              // virtual size of the loaded module
  DWORD    TimeDateStamp;          // date/time stamp from pe header
  DWORD    CheckSum;               // checksum from the pe header
  DWORD    NumSyms;                // number of symbols in the symbol table
  SYM_TYPE SymType;                // type of symbols loaded
  CHAR     ModuleName[32];         // module name
  CHAR     ImageName[256];         // image name
  CHAR     LoadedImageName[256];   // symbol file name
} IMAGEHLP_MODULE64_V1;

typedef struct IMAGEHLP_MODULE64_V2 {
    DWORD    SizeOfStruct;           // set to sizeof(IMAGEHLP_MODULE64)
    DWORD64  BaseOfImage;            // base load address of module
    DWORD    ImageSize;              // virtual size of the loaded module
    DWORD    TimeDateStamp;          // date/time stamp from pe header
    DWORD    CheckSum;               // checksum from the pe header
    DWORD    NumSyms;                // number of symbols in the symbol table
    SYM_TYPE SymType;                // type of symbols loaded
    CHAR     ModuleName[32];         // module name
    CHAR     ImageName[256];         // image name
    CHAR     LoadedImageName[256];   // symbol file name
    // new elements: 07-Jun-2002
    CHAR     LoadedPdbName[256];     // pdb file name
    DWORD    CVSig;                  // Signature of the CV record in the debug directories
    CHAR     CVData[MAX_PATH * 3];   // Contents of the CV record
    DWORD    PdbSig;                 // Signature of PDB
    GUID     PdbSig70;               // Signature of PDB (VC 7 and up)
    DWORD    PdbAge;                 // DBI age of pdb
    BOOL     PdbUnmatched;           // loaded an unmatched pdb
    BOOL     DbgUnmatched;           // loaded an unmatched dbg
    BOOL     LineNumbers;            // we have line number information
    BOOL     GlobalSymbols;          // we have internal symbol information
    BOOL     TypeInfo;               // we have type information
} IMAGEHLP_MODULE64_V2;

typedef struct IMAGEHLP_MODULE64_V3 {
    DWORD    SizeOfStruct;           // set to sizeof(IMAGEHLP_MODULE64)
    DWORD64  BaseOfImage;            // base load address of module
    DWORD    ImageSize;              // virtual size of the loaded module
    DWORD    TimeDateStamp;          // date/time stamp from pe header
    DWORD    CheckSum;               // checksum from the pe header
    DWORD    NumSyms;                // number of symbols in the symbol table
    SYM_TYPE SymType;                // type of symbols loaded
    CHAR     ModuleName[32];         // module name
    CHAR     ImageName[256];         // image name
    CHAR     LoadedImageName[256];   // symbol file name
    // new elements: 07-Jun-2002
    CHAR     LoadedPdbName[256];     // pdb file name
    DWORD    CVSig;                  // Signature of the CV record in the debug directories
    CHAR     CVData[MAX_PATH * 3];   // Contents of the CV record
    DWORD    PdbSig;                 // Signature of PDB
    GUID     PdbSig70;               // Signature of PDB (VC 7 and up)
    DWORD    PdbAge;                 // DBI age of pdb
    BOOL     PdbUnmatched;           // loaded an unmatched pdb
    BOOL     DbgUnmatched;           // loaded an unmatched dbg
    BOOL     LineNumbers;            // we have line number information
    BOOL     GlobalSymbols;          // we have internal symbol information
    BOOL     TypeInfo;               // we have type information
    // new elements: 17-Dec-2003
    BOOL     SourceIndexed;          // pdb supports source server
    BOOL     Publics;                // contains public symbols
} IMAGEHLP_MODULE64_V3;

typedef struct IMAGEHLP_MODULE64_V4 {
    DWORD    SizeOfStruct;           // set to sizeof(IMAGEHLP_MODULE64)
    DWORD64  BaseOfImage;            // base load address of module
    DWORD    ImageSize;              // virtual size of the loaded module
    DWORD    TimeDateStamp;          // date/time stamp from pe header
    DWORD    CheckSum;               // checksum from the pe header
    DWORD    NumSyms;                // number of symbols in the symbol table
    SYM_TYPE SymType;                // type of symbols loaded
    CHAR     ModuleName[32];         // module name
    CHAR     ImageName[256];         // image name
    // new elements: 07-Jun-2002
    CHAR     LoadedImageName[256];   // symbol file name
    CHAR     LoadedPdbName[256];     // pdb file name
    DWORD    CVSig;                  // Signature of the CV record in the debug directories
    CHAR     CVData[MAX_PATH * 3];   // Contents of the CV record
    DWORD    PdbSig;                 // Signature of PDB
    GUID     PdbSig70;               // Signature of PDB (VC 7 and up)
    DWORD    PdbAge;                 // DBI age of pdb
    BOOL     PdbUnmatched;           // loaded an unmatched pdb
    BOOL     DbgUnmatched;           // loaded an unmatched dbg
    BOOL     LineNumbers;            // we have line number information
    BOOL     GlobalSymbols;          // we have internal symbol information
    BOOL     TypeInfo;               // we have type information
    // new elements: 17-Dec-2003
    BOOL     SourceIndexed;          // pdb supports source server
    BOOL     Publics;                // contains public symbols
    // new element: 15-Jul-2009
    DWORD    MachineType;            // IMAGE_FILE_MACHINE_XXX from ntimage.h and winnt.h
    DWORD    Reserved;               // Padding - don't remove.
} IMAGEHLP_MODULE64_V4;
#pragma pack(pop)

// SymInitialize()
typedef BOOL (__stdcall *tSI)( IN HANDLE hProcess, IN PSTR UserSearchPath, IN BOOL fInvadeProcess );
tSI pSI;

// SymLoadModule64()
typedef DWORD64 (__stdcall *tSLM)( IN HANDLE hProcess, IN HANDLE hFile,
  IN PSTR ImageName, IN PSTR ModuleName, IN DWORD64 BaseOfDll, IN DWORD SizeOfDll );
tSLM pSLM;

// SymGetModuleInfo64()
typedef BOOL (__stdcall *tSGMI_V1)( IN HANDLE hProcess, IN DWORD64 dwAddr, OUT IMAGEHLP_MODULE64_V1 *ModuleInfo );
tSGMI_V1 pSGMI_V1;
typedef BOOL (__stdcall *tSGMI_V2)( IN HANDLE hProcess, IN DWORD64 dwAddr, OUT IMAGEHLP_MODULE64_V2 *ModuleInfo );
tSGMI_V2 pSGMI_V2;
typedef BOOL (__stdcall *tSGMI_V3)( IN HANDLE hProcess, IN DWORD64 dwAddr, OUT IMAGEHLP_MODULE64_V3 *ModuleInfo );
tSGMI_V3 pSGMI_V3;
typedef BOOL (__stdcall *tSGMI_V4)( IN HANDLE hProcess, IN DWORD64 dwAddr, OUT IMAGEHLP_MODULE64_V4 *ModuleInfo );
tSGMI_V4 pSGMI_V4;


int main()
{
  // Load dbghelp.dll:
  HMODULE m_hDbhHelp = NULL;
  TCHAR szTemp[4096];
#ifdef _M_IX86
        if ( (m_hDbhHelp == NULL) && (GetEnvironmentVariable(_T("ProgramFiles"), szTemp, 4096) > 0) )
        {
          _tcscat_s(szTemp, _T("\\Debugging Tools for Windows (x86)\\dbghelp.dll"));
          // now check if the file exists:
          if (GetFileAttributes(szTemp) != INVALID_FILE_ATTRIBUTES)
          {
            m_hDbhHelp = LoadLibrary(szTemp);
          }
        }
#elif _M_X64
        if ( (m_hDbhHelp == NULL) && (GetEnvironmentVariable(_T("ProgramFiles"), szTemp, 4096) > 0) )
        {
          _tcscat_s(szTemp, _T("\\Debugging Tools for Windows (x64)\\dbghelp.dll"));
          // now check if the file exists:
          if (GetFileAttributes(szTemp) != INVALID_FILE_ATTRIBUTES)
          {
            m_hDbhHelp = LoadLibrary(szTemp);
          }
        }
#elif _M_IA64
        if ( (m_hDbhHelp == NULL) && (GetEnvironmentVariable(_T("ProgramFiles"), szTemp, 4096) > 0) )
        {
          _tcscat_s(szTemp, _T("\\Debugging Tools for Windows (ia64)\\dbghelp.dll"));
          // now check if the file exists:
          if (GetFileAttributes(szTemp) != INVALID_FILE_ATTRIBUTES)
          {
            m_hDbhHelp = LoadLibrary(szTemp);
          }
        }
#endif

    pSI = (tSI) GetProcAddress(m_hDbhHelp, "SymInitialize" );
    pSLM = (tSLM) GetProcAddress(m_hDbhHelp, "SymLoadModule64" );
    pSGMI_V1 = (tSGMI_V1) GetProcAddress(m_hDbhHelp, "SymGetModuleInfo64" );
    pSGMI_V2 = (tSGMI_V2) GetProcAddress(m_hDbhHelp, "SymGetModuleInfo64" );
    pSGMI_V3 = (tSGMI_V3) GetProcAddress(m_hDbhHelp, "SymGetModuleInfo64" );
    pSGMI_V4 = (tSGMI_V4) GetProcAddress(m_hDbhHelp, "SymGetModuleInfo64" );

    HANDLE hProcess = GetCurrentProcess();
    DWORD64 baseAddr = (DWORD64) GetModuleHandle(NULL);

    // SymInitialize
    BOOL bRet = pSI(hProcess, NULL, FALSE);
    assert(bRet != FALSE);

    // Load the symbols:
    HANDLE hSnap = CreateToolhelp32Snapshot(TH32CS_SNAPMODULE, GetCurrentProcessId()); 
    assert(hSnap != (HANDLE) -1);
    MODULEENTRY32 me;
    me.dwSize = sizeof(me);
    Module32First(hSnap, &me);
    DWORD64 dw64 = pSLM(hProcess, 0, me.szExePath, me.szModule, (DWORD64) me.modBaseAddr, me.modBaseSize);

    // V1
    IMAGEHLP_MODULE64_V1 *pDataV1;
    pDataV1 = new IMAGEHLP_MODULE64_V1;
    memset(pDataV1, 0, sizeof(IMAGEHLP_MODULE64_V1));
    pDataV1->SizeOfStruct = sizeof(IMAGEHLP_MODULE64_V1);
    if (pSGMI_V1(hProcess, baseAddr, pDataV1) != FALSE)
      printf("V1 is working...\n");
    else
      printf("V1 is NOT working...\n");

    // V2
    IMAGEHLP_MODULE64_V2 *pDataV2;
    pDataV2 = new IMAGEHLP_MODULE64_V2;
    memset(pDataV2, 0, sizeof(IMAGEHLP_MODULE64_V2));
    pDataV2->SizeOfStruct = sizeof(IMAGEHLP_MODULE64_V2);
    if (pSGMI_V2(hProcess, baseAddr, pDataV2) != FALSE)
      printf("V2 is working...\n");
    else
      printf("V2 is NOT working...\n");

    // V3
    IMAGEHLP_MODULE64_V3 *pDataV3;
    pDataV3 = new IMAGEHLP_MODULE64_V3;
    memset(pDataV3, 0, sizeof(IMAGEHLP_MODULE64_V3));
    pDataV3->SizeOfStruct = sizeof(IMAGEHLP_MODULE64_V3);
    if (pSGMI_V3(hProcess, baseAddr, pDataV3) != FALSE)
      printf("V3 is working...\n");
    else
      printf("V3 is NOT working...\n");

    // V4
    IMAGEHLP_MODULE64_V4 *pDataV4;
    pDataV4 = new IMAGEHLP_MODULE64_V4;
    memset(pDataV4, 0, sizeof(IMAGEHLP_MODULE64_V4));
    pDataV4->SizeOfStruct = sizeof(IMAGEHLP_MODULE64_V4);
    if (pSGMI_V4(hProcess, baseAddr, pDataV4) != FALSE)
      printf("V4 is working...\n");
    else
      printf("V4 is NOT working...\n");

    delete pDataV1;
    delete pDataV2;
    delete pDataV3;
    delete pDataV4;
}

